<?php

namespace Teknisa\MAN\Controllers;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Utilities;

class LojaParametrizacaoCmdController extends CrudWithParameterBag {

    protected $dataSourceName = 'ger12300_cadloja_parametrizacao_cmd';
    protected $parameterBagColumns = array('CDFILIAL', 'CDLOJA', 'NRORG');
    protected $utilService;
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService, $connection) {
        $this->utilService = $utilService;
        parent::__construct($dataSourceManager, $parameterBag);
        $this->connection = $connection;
        
    }
    
    public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        $data = $request->getDataSet()->getRows();
        $queryLoja = "UPDATE
                        LOJA 
                    SET
                        IDINFMESACOM   = :IDINFMESACOM,
                        IDINFVENDCOM   = :IDINFVENDCOM,
                        IDINFCONSCOM   = :IDINFCONSCOM,
                        IDCOMANDAAUT   = :IDCOMANDAAUT,
                        NRMESAPADRAO   = :NRMESAPADRAO,
                        IDBLOQCOMPARC  = :IDBLOQCOMPARC,
                        IDAGRUPAPEDCOM = :IDAGRUPAPEDCOM,
                        IDREUTILIZACMD = :IDREUTILIZACMD
                        
                    WHERE
                        (NRORG = :NRORG) 
                        AND 
                        (CDLOJA = :CDLOJA) 
                        AND 
                        (CDFILIAL = :CDFILIAL)";
                        
        $stmt = $this->connection->prepare($queryLoja); 
		$stmt->execute(array(
		    "IDINFMESACOM" => $data[0]['IDINFMESACOM'],
		    "IDINFVENDCOM" => $data[0]['IDINFVENDCOM'],
            "IDINFCONSCOM" => $data[0]['IDINFCONSCOM'],
            "IDCOMANDAAUT" => $data[0]['IDCOMANDAAUT'],
            "NRMESAPADRAO" => $data[0]['NRMESAPADRAO'],
            "IDBLOQCOMPARC" => $data[0]['IDBLOQCOMPARC'],
            "IDAGRUPAPEDCOM" => $data[0]['IDAGRUPAPEDCOM'],
            "IDREUTILIZACMD" => $data[0]['IDREUTILIZACMD'],
            "NRORG" => $data[0]['NRORG'],
		    "CDLOJA" => $data[0]['CDLOJA'],
		    "CDFILIAL" => $data[0]['CDFILIAL']
		));
    }

    
}
