<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use Utilities\NfceConfigReader;
use Utilities\NfceConfigCreator;
use Doctrine\ORM\EntityManager;

if (!defined('PATH_NFCEPHP')) {
    define('PATH_NFCEPHP', Utilities::nfcePath());
}

class ConfigAmbientNFCE {

    protected $entityManager;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getFilialData($cdfilial, $nrorg) {
        try{
            $params = array(
                'CDFILIAL' => $cdfilial,
                'NRORG' => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_DADOS_FILIAL, $params);
        }catch(\Exception $e){
            var_dump($e->getMessage());
        }  
    }

    public function getPlaceData($cdfilial, $nrorg) {
        try{
            $params = array(
                'CDFILIAL' => $cdfilial,
                'NRORG' => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_DADOS_LOCAL, $params);
        }catch(\Exception $e){
            var_dump($e->getMessage());
        }  
    }

    public function getParavend($cdfilial, $nrorg) {
        try{
            $params = array(
                'CDFILIAL' => $cdfilial,
                'NRORG' => $nrorg
            );
            return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_PARAVEND, $params);
        }catch(\Exception $e){
            var_dump($e->getMessage());
        }  
    }

    public function getFileData($cdfilial, $nrorg, $nrinsjurfili){
        $fileReader = new NfceConfigReader();
        $filePath = PATH_NFCEPHP;
        $fileName = self::createFileName($nrinsjurfili, $nrorg);
        $fileData = $fileReader->readConfig($fileName, $filePath);
        if($fileData)
            return $fileData;
        else
            return array();
    }

    public function saveFileData($row, $nrinsjurfili, $nrorg){
        try{
            $this->entityManager->getConnection()->beginTransaction();

            $params = array(
                'IDAMBTRABNFCE'=> $row['tpAmb'], 
                'DSDIRARQLOGNFCE'=> $row['pathNFeFiles'], 
                'CDCODSCONSHOMO'=> $row['tokenNFCe'], 
                'CDIDTOKENHOMO'=> $row['tokenNFCeId'], 
                'CDFILIAL'=> $row['CDFILIAL'], 
                'NRORG'=> $row['NRORG'],
                'DTULTATU' => $row['DTULTATU'],
                'CDOPERULTATU' => $row['CDOPERULTATU'],
                'NRORGULTATU' => $row['NRORGULTATU']
            );
            $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_PARAVEND, $params);

            $fileCreator = new NfceConfigCreator();
            $filePath = PATH_NFCEPHP;
            $fileName = self::createFileName($nrinsjurfili, $nrorg);
            $message = $fileCreator->createConfig($row, $fileName, $filePath);
            if ($message[1] != "error"){
                $this->entityManager->getConnection()->commit();
            }
            else {
                $this->entityManager->getConnection()->rollBack();
            }
            
            return $message;
        }
        catch (Exception $e){
            $this->entityManager->getConnection()->rollBack();
            return ["Erro ao criar o arquivo!", "error"];
        }

    }

    public function createFileName($nrinsjurfili, $nrorg){
        $fileName = $nrinsjurfili."_".$nrorg;
        return $fileName; 
    }
}