<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class LancamentoCliConsumidorService {

	protected $entityManager; 
	
	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;

    }

	public function buscaDados($cdfilial, $dtinicial, $dtfinal, $produtoinicial, $produtofinal, $cdloja, $cdcliente, $nrorg, $idrelatorio, $cdconsumidor) {

	    $params = array(
     	":CDFILIAL" => (is_null($cdfilial)) ? "" : $cdfilial,
     	":CDLOJA" => (is_array($cdloja)  && count($cdloja) != 0) ? implode('_' ,$cdloja) : "",
     	":CDCLIENTE" => (is_array($cdcliente)  && count($cdcliente) != 0) ? implode('_' ,$cdcliente) : "",
     	":CDCONSUMIDOR" => (is_array($cdconsumidor)  && count($cdconsumidor) != 0) ? implode('_' ,$cdconsumidor) : "",
     	":CDPRODINI" => $produtoinicial,
     	":CDPRODFIM" => $produtofinal,
     	":DTLANCINI" => $dtinicial,
     	":DTLANCFIN" => $dtfinal,
     	":CDPRODUTO" => null,
     	":TCDPRODUTO" => ($produtoinicial) ? "N" : "T",
     	":TCDFILIAL" => (is_null($cdfilial)) ?  "T" : "N",
     	":TCDLOJA" => (is_array($cdloja)  && count($cdloja) != 0) ?  "N" : "T",
     	":TCDCLIENTE" => (is_array($cdcliente)  && count($cdcliente) != 0) ?  "N" : "T",
     	":TCDCONSUMIDOR" => (is_array($cdconsumidor)  && count($cdconsumidor) != 0) ?  "N" : "T",
     	":NRORG" => $nrorg
 		);
 		ini_set('memory_limit', '3G');
        
 		switch($idrelatorio){
            case 0:
 				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_PADRAO, $params);
		        return $response;
		    break;

			case 1:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_VIQUA, $params);
				return $response;
			break;
			case 2:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_VALMET, $params);
				return $response;
			break;
			case 3:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_VALEO, $params);
				return $response;
			break;
			case 4:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_TOLEDO, $params);
				return $response;
			break;
			case 5:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_MAXION, $params);
				return $response;
			break;
			case 6:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_HYUNDAI, $params);
				return $response;
			break;
			case 7:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_HAYESMULTI, $params);
				return $response;
			break;
			case 8:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_HAYESREFEICAO, $params);
				return $response;
			break;
			case 9:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_EMS, $params);
				return $response;
			break;
			case 10:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_COLGATE, $params);
				return $response;
			break;
			case 11:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_BRASIL_GRAFICA, $params);
				return $response;
			break;
			case 12:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_AGC_VIDROS, $params);
				return $response;
			break;
			case 13:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_GEVISA, $params);
				return $response;
			break;
			case 14:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_MALWEE, $params);
				return $response;
			break;
			case 15:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_AXALTA, $params);
				return $response;
			break;
			case 16:
				$response = $this->entityManager->getConnection()->fetchAll(self::BUSCA_REL_CONS_SODEXO_AMSTED, $params);
				return $response;
			break;
 		}

	}

	const BUSCA_REL_CONS_SODEXO_PADRAO = "
        SELECT   
            SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) || ';' AS CDCONSUMIDOR,
            SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40) || ';' AS NMCONSUMIDOR,
            TRIM(REPLACE(TO_CHAR(SUM(MO.VRMOVCLI), '0000000.00'),'.',',')) AS VRMOVCLI
        FROM 
            VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
            (VE.CDFILIAL     = :CDFILIAL    ) AND
            (VE.IDSITUVENDA  = 'O'            ) AND
            (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
            (VE.CDFILIAL     = MO.CDFILIAL    ) AND
            (VE.CDCAIXA      = MO.CDCAIXA     ) AND
            (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
            (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
            (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
            (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
            ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
            ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
            ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
            SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10),
            SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40)
        ORDER BY
            SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10)
    ";

    const BUSCA_REL_CONS_SODEXO_VIQUA = "
        SELECT
           CO.CDCLIENTE AS CDCLI ,   
           CO.CDCONSUMIDOR || ' ' AS CDCONSUMIDOR,
           CO.NMCONSUMIDOR || ' ' AS NMCONSUMIDOR,
           :DTLANCINI || ' À ' || :DTLANCFIN AS PERIODO ,
           SUM(MO.VRMOVCLI) AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           CO.CDCLIENTE,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR
        ORDER BY
           CO.CDCLIENTE,
           CO.CDCONSUMIDOR
   ";
   
   const BUSCA_REL_CONS_SODEXO_VALMET = "
        SELECT   
           LTRIM(CO.CDCONSUMIDOR,'0') AS CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           TO_CHAR(SUM(MO.VRMOVCLI),'999999999990d00') AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           LTRIM(CO.CDCONSUMIDOR,'0'),
           CO.NMCONSUMIDOR
        ORDER BY
           LTRIM(CO.CDCONSUMIDOR,'0')
   ";
   
   
    const BUSCA_REL_CONS_SODEXO_VALEO = "
        SELECT
           CO.CDCLIENTE AS CDCLI,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           CO.CDIDCONSUMID,
           CO.CDCCUSCLIE,
           TO_CHAR(SUM(MO.VRMOVCLI),'999999999990d00') AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           CO.CDCLIENTE,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           CO.CDIDCONSUMID,
           CO.CDCCUSCLIE
        ORDER BY
           CO.CDCLIENTE,
           CO.CDCONSUMIDOR
    ";
   
    const BUSCA_REL_CONS_SODEXO_TOLEDO = "
        SELECT   
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) || ';' AS CDCONSUMIDOR,
           SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40) || ';' AS NMCONSUMIDOR,
           TRIM(REPLACE(TO_CHAR(SUM(MO.VRMOVCLI), '0000000.00'),'.',',')) AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10),
           SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40)
        ORDER BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10)
    ";
   
    const BUSCA_REL_CONS_SODEXO_MAXION = "
        SELECT
           TO_CHAR(TO_DATE(:DTLANCINI, 'DD-MM-YYYY'), 'YYYY') || ';' AS ANO,   
           TO_CHAR(TO_DATE(:DTLANCINI, 'DD-MM-YYYY'), 'MM') || ';' AS MES,      
           '2064;' AS FIRST,
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),14,8) || ';' AS CDCONSUMIDOR,
           '0;' AS SECOND,
           TRIM(REPLACE(TO_CHAR(SUM(MO.VRMOVCLI), '000000000000.00'),'.',',')) || ';' AS VRMOVCLI,
           '1' AS THIRD
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),14,8)
        ORDER BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),14,8)
    ";
   
    const BUSCA_REL_CONS_SODEXO_HYUNDAI = "
        SELECT
           CO.CDCLIENTE,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           CO.CDCCUSCLIE,
           :DTLANCINI AS DTINI,
           :DTLANCFIN AS DTFIN,
           TO_CHAR(SUM(MO.VRMOVCLI),'999999999990d00') AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           CO.CDCLIENTE,
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           CO.CDCCUSCLIE
        ORDER BY
           CO.CDCLIENTE,
           CO.CDCONSUMIDOR
    ";

    const BUSCA_REL_CONS_SODEXO_HAYESMULTI = "
        SELECT   
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),16,06) AS CDCONSUMIDOR,
           TO_CHAR(TO_DATE(:DTLANCINI,'DD-MM-YYYY'), 'DDMMYYYY') AS DATA,
           '5511 000000000000,00' AS FIRST,
           TRIM(REPLACE(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)), '000000000000.00'),'.',',')) AS VRCONSUMO,
           TRIM(REPLACE(TO_CHAR(SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)), '000000000000.00'),'.',',')) || 'N' AS SECOND
        FROM 
           VENDA VE, ITEMVENDA IT, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (IT.CDPRODUTO NOT IN ('1403400600','1401197300','1401197400')) AND
           (VE.CDFILIAL     = IT.CDFILIAL    ) AND
           (VE.CDCAIXA      = IT.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = IT.NRSEQVENDA  ) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),16,06)
        ORDER BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),16,06)
    ";
   
   
    const BUSCA_REL_CONS_SODEXO_HAYESREFEICAO = "
        SELECT   
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),16,06) AS CDCONSUMIDOR,
           TO_CHAR(TO_DATE(:DTLANCINI,'DD-MM-YYYY'), 'DDMMYYYY') AS DATA,
           '9530      ' AS FIRST,
           TRIM(REPLACE(TO_CHAR(COUNT(DISTINCT VE.CDFILIAL||VE.CDCAIXA||VE.NRSEQVENDA), '000000000000.00'),'.',',')) AS QTCUPONS,
           '000000000000,00000000000000,00N' AS SECOND
        FROM 
           VENDA VE, ITEMVENDA IT, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (IT.CDPRODUTO IN ('62739','62738')) AND
           (VE.CDFILIAL     = IT.CDFILIAL    ) AND
           (VE.CDCAIXA      = IT.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = IT.NRSEQVENDA  ) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),16,06)
        ORDER BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),16,06)
    ";
   
    const BUSCA_REL_CONS_SODEXO_EMS = "
        SELECT
           CO.CDCLIENTE,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           CL.NRINSJURCLIE,
           CL.IDTPIJURCLIE,
           CL.NMFANTCLIE,
           TO_CHAR(SUM(MO.VRMOVCLI),'999999999990d00') AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           CO.CDCLIENTE,
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           CL.NRINSJURCLIE,
           CL.IDTPIJURCLIE,
           CL.NMFANTCLIE
        ORDER BY
           CO.CDCLIENTE,
           CO.CDCONSUMIDOR
    ";
   
    const BUSCA_REL_CONS_SODEXO_COLGATE = "
        SELECT   
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) || ';' AS CDCONSUMIDOR,
           SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40) || ';' AS NMCONSUMIDOR,
           TRIM(REPLACE(TO_CHAR(SUM(MO.VRMOVCLI), '0000000.00'),'.',',')) AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10),
           SUBSTR(RPAD(CO.NMCONSUMIDOR,40,' '),01,40)
        ORDER BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10)
    ";
   
    const BUSCA_REL_CONS_SODEXO_BRASIL_GRAFICA = "
        SELECT   
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),14,08) AS CDCONSUMIDOR,
           SUBSTR(RPAD(CO.NMCONSUMIDOR,35,' '),01,35) AS NMCONSUMIDOR,
           TRIM(REPLACE(TO_CHAR(SUM(MO.VRMOVCLI), '00000000.00'),'.','')) AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),14,08),
           SUBSTR(RPAD(CO.NMCONSUMIDOR,35,' '),01,35)
        ORDER BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),14,08)
    ";

    const BUSCA_REL_CONS_SODEXO_AGC_VIDROS = "
        SELECT
           CO.CDCLIENTE AS CDCLI,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           :DTLANCINI || ' a ' || :DTLANCFIN AS PERIODO,
           TO_CHAR(SUM(MO.VRMOVCLI),'999999999990d00') AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           CO.CDCLIENTE,   
           CO.CDCONSUMIDOR,
           CO.NMCONSUMIDOR
        ORDER BY
           CO.CDCLIENTE,
           CO.CDCONSUMIDOR
    ";
   
    const BUSCA_REL_CONS_SODEXO_GEVISA = "
        SELECT   
           LTRIM(CO.CDCONSUMIDOR,'0') AS CDCONSUMIDOR,
           CO.NMCONSUMIDOR,
           TO_CHAR(SUM(MO.VRMOVCLI),'999999999990d00') AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           LTRIM(CO.CDCONSUMIDOR,'0'),
           CO.NMCONSUMIDOR
        ORDER BY
           LTRIM(CO.CDCONSUMIDOR,'0')
    ";
   
    const BUSCA_REL_CONS_SODEXO_MALWEE = "
        SELECT
           CO.CDCLIENTE,   
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),13,09) || ';' AS CDCONSUMIDOR,
           SUBSTR(LPAD(CL.NRINSJURCLIE,18,' '),01,18) || ';' AS NRINSJURCLIE,
           '1069;' AS FIRST,
           TRIM(REPLACE(TO_CHAR(SUM(MO.VRMOVCLI), '00000000000.00'),'.','')) AS VRMOVCLI
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           CO.CDCLIENTE,   
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),13,09),
           SUBSTR(LPAD(CL.NRINSJURCLIE,18,' '),01,18)
        ORDER BY
           CO.CDCLIENTE,   
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),13,09)
    ";
   
    const BUSCA_REL_CONS_SODEXO_AXALTA = "
        SELECT
           '900;' as FIRST,
           'REFEICOES   ;' AS PRODUTO,
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) || ';' AS CDCONSUMIDOR,
           TO_CHAR(FIRST_DAY(:DTLANCINI), 'YYYY-MM-DD') || ';' AS DTPERIODO,
           TO_CHAR(SUM(IT.QTPRODVEND), 'FM99999D90','NLS_NUMERIC_CHARACTERS = '',.''') || ';' AS QTCONSUMO,
           '000;' AS VRCONSUMO,
           '000' as LAST
        FROM 
           VENDA VE, ITEMVENDA IT, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = IT.CDFILIAL    ) AND
           (VE.CDCAIXA      = IT.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = IT.NRSEQVENDA  ) AND
           (IT.CDPRODUTO    = '1401100100'   ) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T')) AND
           (SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) LIKE '30%' OR SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) LIKE '34%')
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10)
        UNION ALL
        SELECT
           '900;' as FIRST,
           'MULTIPRODUTO;' AS PRODUTO,
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10)||';' AS CDCONSUMIDOR,
           TO_CHAR(FIRST_DAY(:DTLANCINI), 'YYYY-MM-DD')||';' AS DTPERIODO,
           '000;' AS QTCONSUMO,
           TO_CHAR(SUM(TRUNC(IT.QTPRODVEND * (IT.VRUNITVEND + NVL(IT.VRUNITVENDCL,0)),2) + NVL(IT.VRACRITVEND,0) - NVL(IT.VRDESITVEND,0)), 'FM99999D90','NLS_NUMERIC_CHARACTERS = '',.''')||';' AS VRCONSUMO,
           '000' as LAST
        FROM 
           VENDA VE, ITEMVENDA IT, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = IT.CDFILIAL    ) AND
           (VE.CDCAIXA      = IT.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = IT.NRSEQVENDA  ) AND
           (IT.CDPRODUTO   <> '1401100100'   ) AND
           (IT.CDPRODUTO   <> '1403400100'   ) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T')) AND
           (SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) LIKE '30%' OR SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10) LIKE '34%')
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),12,10)
        ORDER BY
           1, 2

    ";
    
    const BUSCA_REL_CONS_SODEXO_AMSTED = "
        SELECT
           '09' AS FIRST,
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),14,8) AS CDCONSUMIDOR,
           '849001' AS SECOND,
           TRIM(REPLACE(TO_CHAR(SUM(MO.VRMOVCLI), '000000000000.00'),'.','')) AS VRMOVCLI,
           TO_CHAR(SYSDATE, 'DDMMYY') AS DATA_ATUAL,   
           '000000002' AS THIRD
        FROM 
           VENDA VE, MOVICLIE MO, CONSUMIDOR CO, CLIENTE CL
        WHERE
           (VE.CDFILIAL     = :CDFILIAL    ) AND
           (VE.IDSITUVENDA  = 'O'            ) AND
           (VE.DTENTRVENDA BETWEEN :DTLANCINI AND :DTLANCFIN) AND
           (VE.CDFILIAL     = MO.CDFILIAL    ) AND
           (VE.CDCAIXA      = MO.CDCAIXA     ) AND
           (VE.NRSEQVENDA   = MO.NRSEQVENDA  ) AND
           (CO.CDCLIENTE    = MO.CDCLIENTE   ) AND
           (CO.CDCONSUMIDOR = MO.CDCONSUMIDOR) AND
           (CL.CDCLIENTE    = MO.CDCLIENTE   ) AND
           ((INSTR(:CDLOJA      , VE.CDFILIAL||VE.CDLOJA       ) <> 0) OR (:TCDLOJA       = 'T')) AND
           ((INSTR(:CDCLIENTE   , CL.CDCLIENTE                 ) <> 0) OR (:TCDCLIENTE    = 'T')) AND
           ((INSTR(:CDCONSUMIDOR, CO.CDCLIENTE||CO.CDCONSUMIDOR) <> 0) OR (:TCDCONSUMIDOR = 'T'))
        GROUP BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),14,8)
        ORDER BY
           SUBSTR(LPAD(CO.CDCONSUMIDOR,21,'0'),14,8)
    ";

}  